#include <string.h>
#include <stdio.h>

using namespace std;

struct Buyer {
	bool sell;
	float price;
	char* name; 
	Buyer(char* name, bool sell, float price){
		this->name = new char[strlen(name)+1];
		strcpy(this->name,name);
		this->name[strlen(name)] = 0;
		this->sell = sell;
		this->price = price;
	}
	~Buyer(){
		delete[] name;
	}
};



int main(){

	int count = 0;
	char issuer[11];

	
	scanf("%d %s",&count,issuer);

while(count != 0){
	
	Buyer* bs[count];

	char sell[5];
	char name[21];
	bool willSell = false;
	float bid = 0;
	for(int i =0; i<count; i++){
		scanf("%s %s %f",name,sell,&bid);
		willSell = (strcmp(sell,"sell")==0);
		
		bs[i] = new Buyer(name,willSell,bid);
	}
	
	printf("%s\n",issuer);

	for(int i=0;i<count;i++){
		printf("%s:",bs[i]->name);

		bool sold = false;

		if(bs[i]->sell){
			for(int j=0;j<count;j++){
				if(j==i) continue;
				if(!(bs[j]->sell) && bs[j]->price >= bs[i]->price){
					printf(" %s",bs[j]->name);
					sold=true;
				}
			}
		}		
		else {
			for(int j=0;j<count;j++){
				if(j==i) continue;
				if(bs[j]->sell && bs[j]->price <= bs[i]->price){
					printf(" %s",bs[j]->name);
					sold=true;
				}
			}
		}
		if(!sold) printf(" NO-ONE");
		printf("\n");
	}

	for(int i =0;i<count;i++){
		delete bs[i];
	}
	scanf("%d %s",&count,issuer);
}
	return 0;
}
